# Copyright (C) 2002-2003 Juan David Ibez Palomar <jdavid@itaapy.com>
#               2003 Itaapy <contact@itaapy.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA


__revision__ = "$Id: __init__.py,v 1.3 2003/08/04 10:11:54 jdavid Exp $"


import os
import sys


def get_abspath(globals_namespace, local_path):
    """
    Returns the absolute path to the required file.
    """
    mname = globals_namespace['__name__']
    module = sys.modules[mname]
    if hasattr(module, '__path__'):
        mpath = module.__path__[0]
    elif '.' in mname:
        mpath = sys.modules[mname[:mname.rfind('.')]].__path__[0]
    else:
        mpath = mname
    path = os.path.join(os.getcwd(), mpath)

    return os.path.join(mpath, local_path)
