# -*- coding: ISO-8859-1 -*-
# Copyright (C) 2002-2003 Juan David Ibez Palomar <jdavid@itaapy.com>
#               2003 Itaapy <contact@itaapy.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA


__revision__ = '$Id: test_index.py,v 1.4 2003/08/05 09:11:25 jdavid Exp $'


from sets import Set
import unittest

from index import ValueIndex, ExprIndex


class ValueIndexTestCase(unittest.TestCase):
    def test_one2one(self):
        good = ValueIndex()
        good.add('python', True)
        good.add('perl', False)

        assert good._is(True) == Set(['python'])


    def test_one2n(self):
        color = ValueIndex()
        color.add('sky', 'blue')
        color.add('fire', 'red')
        color.add('sea', 'ble')
        color.add('night', 'black')
        color.add('sun', 'yellow')

        assert color._in(['yellow', 'red']) == Set(['sun', 'fire'])


    def test_n2one(self):
        keywords = ValueIndex()
        keywords.add('python', 'simple', 'slow')
        keywords.add('perl', 'complex', 'slow')
        keywords.add('c', 'complex', 'fast')

        assert keywords._is('simple') == Set(['python'])


    def test_n2n(self):
        keywords = ValueIndex()
        keywords.add('python', 'simple', 'slow')
        keywords.add('perl', 'complex', 'slow')
        keywords.add('c', 'complex', 'fast')

        assert keywords._in(['simple', 'fast']) == Set(['python', 'c'])


    def test_starts(self):
        path = ValueIndex()
        path.add('x', 'a')
        path.add('y', 'a/b')
        path.add('z', 'a/b/c')

        assert path._starts('a/b') == Set(['y', 'z'])



class ExprIndexTestCase(unittest.TestCase):
    def test_search(self):
        index = ExprIndex()
        index.add('python', "lambda: 1")
        index.add('perl', "lambda: 0")

        print index.search()
##        assert index.search() == Set(['python'])



if __name__ == '__main__':
    unittest.main()
